<?php
require_once( 'api/Storage/TokenStorageInterface.php' );
require_once( 'api/Storage/FileStorage.php' );
require_once( 'api/sendpulseInterface.php' );
require_once( 'api/sendpulse.php' );


class modelScPushnotifications extends cmsModel {

    private $SPApiProxy = false;
    private $is_configured= false;
    public $options            = array();

    public function __construct() {

        parent::__construct();

        $this->options = cmsController::loadOptions('sc_pushnotifications');

        if (!isset($this->options['sendpulse_site_id'])){$this->options['sendpulse_site_id']=0;}
        $this->site_id =$this->options['sendpulse_site_id'];
        if ($this->options['sendpulse_id']){
            try {
                $this->SPApiProxy = new SendpulseApi( $this->options['sendpulse_id'], $this->options['sendpulse_secret'], new FileStorage());
                $this->is_configured = true;
            } catch (Exception $e) {
            }
        }
    }

    public function getSubscribers($offset, $limit) {

        if (!$this->is_configured){return array();}

        if (!isset($this->options['sendpulse_site_id'])){$this->options['sendpulse_site_id']=0;}

        $res = $this->SPApiProxy->pushListWebsiteSubscriptions($this->options['sendpulse_site_id'],$limit,$offset);

        $users = array();
        foreach($res as $item){

            $user = array(
                'id'=>$item->id,
                'browser' => $item->browser,
                'os' => $item->os,
                'city' => $item->city,
                'UserId' => $item->variables->UserId,
                'UserNickname' => $item->variables->UserNickname,
                'subscription_date' => $item->subscription_date
            );
            $users[]=$user;
        }
        return $users;
    }

    public function getSubscribersTotal($num=false) {
        if (!$this->is_configured){return array();}
        if (!isset($this->options['sendpulse_site_id'])){$this->options['sendpulse_site_id']=0;}

        $res = $this->SPApiProxy->pushCountWebsiteSubscriptions($this->options['sendpulse_site_id']);

        return $res;
    }

    public function getListWebsites() {
        if (!$this->is_configured){return array();}

        try {
            $res = $this->SPApiProxy->pushListWebsites();
        } catch (Exception $e) {
            return array();
        }

        return $res;
    }

    public function sendPush($data){
        if (!$this->is_configured){return array();}

        $task = array(
            'title'      => $data['title'],
            'body'       => $data['content'],
            'website_id' => $this->options['sendpulse_site_id'],
            'ttl'        => 20,
            'stretch_time' => 10
        );
        $additionalParams = array(
            'link' => $data['url'],
            'filter' => '{"variable_name":"UserId","operator":"and","conditions":[{"condition":"equal","value":'.$data['user_id'].'}]}'
        );


        $this->SPApiProxy->createPushTask($task, $additionalParams);

    }


}
